var/list/suspicions = list()
var/list/fungiNames = list()


world
	name = "The Fungus Among Us"
	view = "11x1"
	turf = /turf/scenery
	mob = /mob/player


	New()
		. = ..()
		spawn(1) Initialize()


	proc/Initialize()
		//exits and arrivals are connections between areas/turfs; since they point directly
		//to objects, they can't be resolved until the world's areas are all created.
		for(var/area/A in world)
			A.InitializeExits()

		for(var/area/A in world)
			A.InitializeArrivals()

		//populate items randomly
		var/turf/fixture/swap/S
		var/list/cabinets = list()
		for(S in world) cabinets += S

		var/list/autopop = list(/obj/item/pistol = 3, /obj/item/flamethrower = 2,
			/obj/item/fire_axe = 4, /obj/item/dynamite = 6, /obj/item/clothing = 5)

		for(var/curtype in autopop)
			for(var/i in 1 to autopop[curtype])
				var/obj/item/O = new curtype()
				S = pick(cabinets)
				O.loc = S
				cabinets -= S

		if(length(cabinets))
			world << "[length(cabinets)] cabinets unfilled"

		spawn MaintainSuspicion()


	proc/MaintainSuspicion()
		var
			humancount; fungicount

		while(1)
			humancount = 0
			fungicount = 0
			suspicions.len = 0
			fungiNames.len = 0
			for(var/mob/player/M in players)
				if(M.suspected) suspicions += M.name

				if(M.icon_state == "human") ++humancount
				else if(M.icon_state in fungistates)
					++fungicount
					fungiNames += M.name

			if(gameOn)
				if((!humancount) || (!fungicount))
					DeclareVictory(humancount, fungicount)
					return

				if(world.time >= deadline)
					DeclareVictory(humancount, fungicount)
					return

			//update suspicions list every 2 seconds
			sleep(20)


	proc/DeclareVictory(humancount, fungicount)
		gameOn = 0

		//cheap scoring workaround for when the last human becomes a suicide bomber
		sleep(DYNAMITE_FUSE)

		world << ""

		if(humancount > fungicount)
			world << GetSystemText("<b>Humanity survives!</b>")
		else if(fungicount > humancount)
			world << GetSystemText("<b>Humanity is lost!</b>")
		else if(fungicount == 0)
			world << GetSystemText("<b>Everybody loses!</b>")
		else
			world << GetSystemText("<b>Man and Fungus live together in harmony!</b>")

		world << ""

		for(var/mob/player/M in players)
			world << GetSystemText("[M]: [M.icon_state], score: [M.score]")
			for(var/curline in M.scoredescs)
				world << GetSystemText("    [curline]")

		world << ""

		world << GetSystemText("<center>THE END</center>")

