/*
THE FUNGUS AMONG US (Two-Button Challenge Edition)
Started Jan 23, 2007 for Leftley's two-button game contest.
Submitted March 6, 2007.

Though this is an obvious movie ripoff, I believe the code and icons are my own creations,
and the sounds are in the public domain. Feel free to use any of these elements
in your own games.

ACKNOWLEDGMENTS:
	-- to John Campbell, Howard Hawks, and John Carpenter for asking "Who goes there?";
	-- to Outpost31.com for map inspiration and general info;
	-- to the BYONDers who helped test;
		Airjoe
		Nadrew
		Basik
		DarkCampainger
		DerDragon
		Deadron
		Dalze
		Zaltron
		Nomando
		TheMonkeyDidIt
		ACWraith
		D4RK3 54B3R
		Ryuo
		Yota
		Mizar
		Jon88
		(and to JTGibson for remembering when I first tried to write this in 2002)
	-- and thanks to God that I've only ever seen stuff like this in the movies... so far.

To-do items left undone at deadline:
* wind sound should not play when corpse/observer watches an inside room
* add context-sensitive HUD graphics for A/B buttons
* exploding barrels

* [DONE] flamethrower sound should go to area, not world
* [DONE] reduce duration of fungification paralysis
* [DONE] dynamite explosion reports owner's location instead of its own
* [DONE] when dynamite is used, it gets a flashy icon state
* [DONE] inform player when item grabbed/dropped
* [DONE] Blair Witch syndrome (standing facing wall)
* [DONE] pistol: verify delay between shots is working
* [DONE] pistol should fire even if no target available
* [DONE] add numbers to text overlays and/or make sure "?" works for unsupported chars
* [DONE] mini-map
* [DONE] AI: add rudimentary fungification ability
* [DONE] suspicions text is global -- each player has a "suspected" flag.
* [DONE] review code for thorough comments
* [DONE] add host option to convert observer to player
* [DONE] time limit; scoring (both sides get penalties for killing humans); check for team victory
* [DONE] fungi can recognize one another
	point awards:
		start: 2 points
		kill suspected human: -1 point
		kill unsuspected human: -2 points
		die as human: -1 point
		die as fungus: -2 points
* [DONE] auto-drop dynamite on fungification
* [DONE] polish up intro text/instructions


Leftley's Challenge Rules:

All entries must include a .dms script file with the following lines of code:
macro
    a return "buttonA"
    b return "buttonB"
(Chat functions and commands of a purely administrative or social nature
are the only exception to this rule, so long as they do not directly have
any influence on gameplay and are not required to play the game as intended.)

Entries must feature some sort of multiplayer interaction.
Multiple players playing separate games in parallel do not qualify--
a player must be able to have some affect on other players, either directly
or through a shared environment.

Source code must be included for all entries to verify that the limits
on input aren't being circumvented, but you don't have to distribute
the source openly if you don't want to.


Notes below are just included for fun, from the game I originally planned
to make for the contest. The theme changed, but the UI is pretty much the same.

***********************************
OLD NOTES (Lost Ark of Casablanca):
Good goal: Lasik or Brown escapes
Evil goal: Both letters used by any characters before Lasik or Brown can escape

(a Good character who uses a Letter of Transit before L or B has escaped immediately
converts to Evil for team scoring)

scoring (per character):
Total games played to completion
Games on winning Good team
Games on winning Evil team
Backstabs (leaving on plane as Good character)
Games with most deaths
Games with most artifacts
Games with most money

A button:
	if moving: turn
	if stopped: use fixture if present, item if not
B button:
	if stopped: move
	if moving: stop (and show fixture description in statpanel)

Sample "use fixture" icons:
	move up/down (left/right requires no fixture)
	swap item (tables, cabinets, traders)
	buy/sell stuff (merchants)
	travel
		train: move to next station
		motorcycle: move to home base
		airplane: leave town; must have letter of transit
	hide (barrel, etc.)
		only works if no other mobs in area
		barrel becomes invisible (fixturehint too)

Seller types:
	tailor: buy a new identity. Each identity has a name, cost, icon/state,
		alignment (team), and maybe other traits (speed, max health, etc.)
	bartender: buy a drink. Increases max health for a time, but causes lurching (whenever
		move timer is reset, there is a chance a tick will be added/removed -- chance varies
		with consumption).

on death, current item is dropped; if treasure, moved to a random plinth, vendor, or dig

use a statpanel for current stats, and also fixture details when stopped.

each screen has an orientation var for the compass display.

piano: the piano in Nick's may be used to trade places with Brown or Lasik if one of them
	has disconnected.

treasures:
	a letter of transit
	the Ark of the Cormorant
	the Malted Falcon
	the Holy Pail
	the Spear of Longitudinus
	the Sanka Stones
	the Ham Samichene Manuscripts
	the Plushonomicon
	the Mummy of King Wibijamen

GOOD (base: Nick's American Bar)
Cleveland Brown (bullwhip) (1)
Thulia Ravenscroft (frying pan)
[Ilse]
Victroli Lasik (3)
Nick
Spam

EVIL (base: Propaganda Ministry Headquarters)
Gohr (coat hanger) (2)
Bollock
Maj. Streusel (4)
monkey [can't use Letter]

NPC's:
Evil:
	stormtrooper -- oppose Good characters
	assassin (scimitar)

Law:
	policeman -- oppose any lawbreakers
	Capt. le Carre

Good:
	street urchin -- like Ewoks, oppose Evil characters
	Smallah

Criminals:
	Testarossa -- sells Letters of Transit to those with enough money
	Oulipo (picks pockets)

shovel
date poison
birds
treasure map
torch
spiders
snakes
intercepted telegrams
hiding-basket
alley cat
motorcycle
hookah
camels
horses
rope descent/ascent
gas can
Ark
truck
watermelons
submarine
airplane
letters of transit
roulette table
police radio
defense stationner?
*/

