//fixme: comment out debug verbs
//mob/verb/ItemTest(T in typesof(/obj/item))
//	set category = "debug" //fixme

//	usr:SwapItemFor(new T)


//mob/verb/OverlayTest(T as text)
//	set category = "debug" //fixme

//	usr:OverlayText(T)


//mob/verb/ResurrectionTest()
//	set category = "debug" //fixme

//	icon_state = "fake human"
//	usr:DieAsHuman()


//mob/verb/FungifyTest(mob/M as mob in world)
//	set category = "debug" //fixme
//
//	M.icon_state = "fake human"


mob/host/verb/start(n as num)
	set category = "Host"
	set desc = "Enter number of AI (computer) players, or 0 for none"

	for(var/i in 1 to n)
		var/mob/player/bot
		bot = new(locate(/area/Rec_Room))
		bot.name = "Bot_[ascii2text(i + 64)]"

	verbs -= /mob/host/verb/start

	spawn(5)
		world << GetSystemText("Begin playing! Game duration is [round(GAME_DURATION / 600)] minutes.")

		var/mob/player/P = pick(players)
		P.icon_state = "fake human"
		P << GetSystemText("\n<b>You are the first fungus! Tell no one!</b>\n")

		gameOn = 1
		deadline = world.time + GAME_DURATION


mob/host/verb/reboot(n as num)
	set category = "Host"
	set desc = "To cancel reboot, enter any number but 1"

	if(n == 1)
		world.Reboot(1)


mob/host/verb/who()
	set category = "Host"
	set desc = "Using this serious host command to cheat is naughty"

	for(var/mob/player/P in world)
		usr << "[P]: [P.icon_state], [P.loc:loc], score: [P.score], conn: [P.client ? "Yes" : "No"]"


mob/host/verb/promote(mob/player/M as mob in world)
	set category = "Host"
	set desc = "Help out observers who were late to the starting line"

	if(M.icon_state == "observer")
		players += M
		M.icon_state = "human"


//host verb: warn -- assign a keyname to observer-only status in future games
//host verb: unwarn -- choose a demoted player to undemote for future games
//host verb: ban -- delete client and automatically reject future login attempts


obj/blood
	icon = 'blood.dmi'
	var/mob/player/incriminated


mob/player
	density = 0
	icon = 'player.dmi'
	icon_state = "human"
	name = "Bot_"
	var
		moving = 0
		delay = 5
		warrants = 0
		alignment = "Neutral"
		observer = 0
		movelock
		area/lastarea
		mob/player/watching
		suspected = 0
		score = 2
		list/scoredescs = list()


	verb/chat(T as text)
		set category = null
		world << "<b>[src]:</b> [T]"


	Stat()
		statpanel("Who goes there?")
		if(loc) stat("Location:", loc:loc)
		if(icon_state in fungistates)
			stat("Fungi:", "")
			stat(fungiNames)
		stat("Suspects:", "")
		stat(suspicions)


	New()
		. = ..()
		lastarea = locate(/area)
		spawn(1) Initialize()


	Login()
		//give hosting controls to the first connected player (should be the host)
		if(!hostMob)
			hostMob = src
			verbs += /mob/host/verb/promote
			verbs += /mob/host/verb/reboot
			verbs += /mob/host/verb/start
			verbs += /mob/host/verb/who


	proc/AdjustScore(value, scoredesc)
		if(!value) return
		scoredescs += "[value]: [scoredesc]"
		score += value


	proc/Initialize()
		watching = src

		//move all new mobs to the Rec Room
		var/area/A = locate(/area/Rec_Room)
		var/turf/T = locate(A.x + 5, A.y, A.z)
		Move(T, 4)

		if(ckey) OverlayText(ckey)
		//AI players get a generic name
		else OverlayText(name)

		//if game hasn't started yet, add player to list of players
		if(!gameOn)
			if(!(src in players)) players += src
		else
			//if game has started, assign observer status to non-players
			if(!(src in players))
				icon_state = "observer"
				src << GetSystemText("Welcome! You have entered as an Observer of a game in progress. You can use your B button (macro B or keypad-Period) to randomly change your view.")

		//show whatever text is in the intro file
		src << file2text(INTROTEXT)

		spawn MovementCycle()


	proc/MovementCycle()
		//this sticks with a mob throughout the whole game. It handles player movement
		//and AI as well.
		var/area/A

		//prevent everyone from moving until host starts game
		while(!gameOn) sleep(5)

		while(1)
			//freeze everyone at end of game
			if(!gameOn) return

			if(IsAlive() && !IsMoveLocked())
				//very simple AI for mobs without clients attached
				if(!client)
					//25% chance of using a given exit
					if(prob(25) && istype(loc, /turf/fixture/exit))
						moving = 0
						loc:Dispatch(src)
					else
						moving = 1
						//randomly turn once in a while
						if(prob(3)) dir = turn(dir, 180)

					if(!istype(loc, /turf/fixture) && prob(AI_FUNGIFY_PROB))
						if(icon_state in canFungify)
							AttemptFungify()

				if(moving)
					if(icon_state == "fake corpse")
						icon_state = "fungus"

					var/turf/T = get_step(src, dir)
					A = src.loc:loc
					if(A.IsOccupiable(T))
						Move(T, dir)
						A.MakeFootstep()
					else
						//if player tries to move to invalid turf,
						//force exit use if applicable
						var/turf/fixture/exit/E = src.loc
						if(istype(E)) E.Dispatch(src)
						else dir = turn(dir, 180)

			sleep(delay)


	verb/buttonA()
		set category = null
		usr:HandleButtonA()


	verb/buttonB()
		set category = null
		usr:HandleButtonB()


	proc/HandleButtonA()
		if(!gameOn) return
		//button A does nothing for observers
		if(!IsAlive()) return
		if(IsMoveLocked()) return

		//for players, button A turns if moving
		if(moving)
			switch(dir)
				if(4) dir = 8
				if(8) dir = 4
				else
					world.log << "Error: [src] had dir [dir]"
					dir = 4

		else
			//if stopped, use fixture if present; else, use current item
			if(istype(loc, /turf/fixture))
				loc:Dispatch(src)
			else
				var/didFungify = 0
				if(icon_state in canFungify)
					didFungify = AttemptFungify()

				if(!didFungify)
					UseItem()


	proc/HandleButtonB()
		if(!gameOn) return

		//for observers, button B allows switching to a random player
		if(!IsAlive())
			client.perspective = EYE_PERSPECTIVE
			watching = pick(players)
			var/area/A = watching.loc:loc
			client.UpdateEye(A)
			return

		if(IsMoveLocked()) return

		//for players, button B starts or stops movement
		if(!moving)
			moving = 1
		else
			moving = 0


	proc/AttemptFungify()
		var/area/A = loc:loc
		var/humanCount = 0
		var/mob/player/target
		for(var/mob/player/P in A.contents)
			if(P.icon_state == "human")
				++humanCount
				//can only fungify when alone with a human
				if(humanCount > 1) return 0
				target = P

		if(get_dist(src, target) <= 1)
			Fungify(target)
			return 1

		return 0


	proc/Fungify(mob/player/target)
		icon_state = "fungus"
		target.icon_state = "fungus"

		//if target is holding dynamite, he uses it!
		var/obj/item/dynamite/D = locate() in target
		if(D)
			//cancel out fungification penalty (i.e., treat as "died as human")
			D.Use(target)
			target.AdjustScore(1, "suicide bomber")

		movelock = world.time + FUNGIFY_DELAY
		moving = 0
		src << fungusPauseText

		target.movelock = world.time + FUNGIFY_DELAY
		target.moving = 0
		target << fungusPauseText

		world << fungifySound
		world << GetAlarmText("The fungus is spreading...")


	proc/SwapItemFor(obj/item/I)
		DropCurrentItem()
		if(I)
			src << GetSystemText("You picked up [I].")
			I.layer = FLOAT_LAYER
			overlays += I
			I.loc = src


	proc/DropCurrentItem()
		for(var/obj/item/I in contents)
			src << GetSystemText("You dropped [I].")
			overlays -= I
			I.layer = OBJ_LAYER
			I.loc = src.loc


	proc/UseItem()
		var/obj/item/I = locate() in contents
		if(I) I.Use(src)


	proc/GetPathAhead()
		//get a list of accessible turfs in the direction the player is facing
		var/list/path = list()
		var/turf
			T = loc
			newT
		var/area/A = T.loc

		while(1)
			newT = get_step(T, dir)
			if(A.IsOccupiable(newT))
				path += newT
				T = newT
			else
				return path


	proc/IsMoveLocked()
		if(movelock > world.time)
			return 1


	proc/DieAsHuman()
		//a simple death from pistol or axe
		var/murder = 0
		moving = 0

		//fixme: if someone sees the blood, and its owner isn't there with it, he
		//becomes a suspect
		var/obj/blood/B = new(src.loc)
		B.incriminated = src

		if(icon_state == "human")
			icon_state = "corpse"
			AdjustScore(-1, "died as human")
			murder = GetMurderPenalty()
		else if(icon_state == "fake human")
			icon_state = "fake corpse"
			src << fungusPauseText
			movelock = world.time + FAKE_DEATH_DELAY

		return murder


	proc/Roast()
		//death by flamethrower
		var/murder = 0
		if(icon_state in livestates)
			if(icon_state == "human")
				AdjustScore(-1, "died as human")
				murder = GetMurderPenalty()
			else AdjustScore(-2, "died as fungus")

		moving = 0
		icon_state = "burnt corpse"
		return murder


	proc/BlowUpRealGood()
		//death by dynamite
		//Farm Film and Video Game Report approves this proc
		var/murder = 0
		if(icon_state in blowupable)
			if(icon_state in livestates)
				if(icon_state == "human")
					AdjustScore(-1, "died as human")
					murder = GetMurderPenalty()
				else AdjustScore(-2, "died as fungus")

			moving = 0
			icon_state = "giblets"

		return murder


	proc/GetMurderPenalty()
		if(suspected) return -1
		else return -2


	proc/IsAlive()
		if(icon_state in livestates) return 1


client
	command_text = "chat "
	var/obj/mapmarker/marker


	Move()
		return 0


	New()
		. = ..()
		Initialize()
		world << GetSystemText("<i>[src] has connected to the game.</i>")


	Del()
		world << GetSystemText("<i>[src] has lost connection to the game.</i>")
		. = ..()


	proc/Initialize()
		//set up the fixture hint holders underneath the map
		var/obj/hud/O
		for(var/curx in 1 to 11)
			O = new()
			O.screen_loc = "[curx],0"
			screen += O

		//set up the mini-map
		O = new()
		O.screen_loc = "0,1"
		O.icon = 'minimap.dmi'
		screen += O

		marker = new()
		marker.screen_loc = "0,1"
		screen += marker


	proc/UpdateMap(area/A)
		//move the player's blip on the map
		marker.screen_loc = "0:[A.mapx - 2],1:[A.mapy - 2]"


	proc/UpdateFixtureHints(area/A)
		var/obj/hud/hint/HH

		//get rid of the last area's hints
		for(HH in screen)
			del HH

		for(var/turf/fixture/TF in A.contents)
			if(TF.hintstate)
				HH = new()
				HH.icon_state = TF.hintstate
				HH.screen_loc = "[TF.x - A.x + 1],0"
				screen += HH


	proc/UpdateEye(area/A)
		//when entering a new area, set the player's client eye to the center of it
		//so the map doesn't scroll as player is walking
		eye = locate(A.x + 5, A.y, A.z)

		//update the HUD with icons appropriate to this area's fixtures
		UpdateFixtureHints(A)

		UpdateMap(A)


obj/hud
	icon = 'fixturehints.dmi'
	icon_state = "background"
	name = ""


	hint
		//just to make sure the hint appears above its background
		layer = OBJ_LAYER + 0.1


obj/mapmarker
	icon = 'minimap.dmi'
	icon_state = "marker"
	layer = FLY_LAYER


